<?php

include_once(dirname(__FILE__).'/../../Common/Global.php');

class ModulePortal extends AppModule
{
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'Portal';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPLv3';
    $this->Description = 'Community portal.';
    $this->Dependencies = array('News');
  }  

  function DoInstall()
  {
  }
  
  function DoUninstall()
  {     
  }
  
  function DoStart()
  {
    $this->System->RegisterPage('', 'PagePortal');
    $this->System->FormManager->RegisterClass('MemberOptions', array(
      'Title' => 'Nastavení domácnosti',
      'Table' => '(SELECT Member.Id, Member.FamilyMemberCount, Subject.Name, Subject.AddressStreet, Subject.AddressTown, Subject.AddressPSC, Subject.IC, Subject.DIC FROM Member JOIN Subject ON Subject.Id = Member.Subject)',
      'Items' => array(
        'Name' => array('Type' => 'String', 'Caption' => 'Fakturační jméno', 'Default' => ''),
        'AddressStreet' => array('Type' => 'String', 'Caption' => 'Ulice', 'Default' => 'Zděchov'),
        'AddressTown' => array('Type' => 'String', 'Caption' => 'Město', 'Default' => 'Zděchov'),
        'AddressPSC' => array('Type' => 'String', 'Caption' => 'PSČ', 'Default' => '75607'),
        'AddressCountry' => array('Type' => 'TCountry', 'Caption' => 'Země', 'Default' => '1'),
        'IC' => array('Type' => 'String', 'Caption' => 'IČ', 'Default' => ''),
        'DIC' => array('Type' => 'String', 'Caption' => 'DIČ', 'Default' => ''),
        'FamilyMemberCount' => array('Type' => 'Integer', 'Caption' => 'Počet osob v domácnosti', 'Default' => '', 'Suffix' => 'osob'),
        'BillingPeriodNext' => array('Type' => 'TFinanceBillingPeriod', 'Caption' => 'Požadované fakturované období', 'Default' => ''),
      ),
    ));
    $this->System->FormManager->RegisterClass('UserOptions', array(
      'Title' => 'Základní nastavení',
      'Table' => 'User',
      'SubmitText' => 'Uložit',
      'Items' => array(
        'Login' => array('Type' => 'String', 'Caption' => 'Přihlašovací jméno', 'Default' => ''),
        'Salt' => array('Type' => 'RandomHash', 'Caption' => 'Sůl', 'Default' => ''),
        'Password' => array('Type' => 'Password', 'Caption' => 'Heslo', 'Default' => ''),
        'Name' => array('Type' => 'String', 'Caption' => 'Zobrazované jméno', 'Default' => ''),
        'Email' => array('Type' => 'String', 'Caption' => 'E-mail', 'Default' => ''),
        'PhoneNumber' => array('Type' => 'String', 'Caption' => 'Telefón', 'Default' => ''),
        'ICQ' => array('Type' => 'String', 'Caption' => 'ICQ', 'Default' => ''),
      ),
    ));
    $this->System->FormManager->RegisterClass('UserRegister', array(
      'Title' => 'Registrace uživatele',
      'SubmitText' => 'Registrovat',
      'Table' => 'User',
      'Items' => array(
        'Login' => array('Type' => 'String', 'Caption' => 'Přihlašovací jméno', 'Default' => ''),
        'Password' => array('Type' => 'Password', 'Caption' => 'Heslo', 'Default' => ''),
        'Password2' => array('Type' => 'Password', 'Caption' => 'Potvrzení hesla', 'Default' => ''),
        'Name' => array('Type' => 'String', 'Caption' => 'Zobrazované jméno', 'Default' => ''),
        'Email' => array('Type' => 'String', 'Caption' => 'E-mail', 'Default' => ''),
        'PhoneNumber' => array('Type' => 'String', 'Caption' => 'Telefón', 'Default' => ''),
        'ICQ' => array('Type' => 'String', 'Caption' => 'ICQ', 'Default' => ''),
      ),
    ));
    $this->System->FormManager->RegisterClass('PasswordRecovery', array(
      'Title' => 'Obnova hesla',
      'SubmitText' => 'Obnovit',
      'Table' => '',
      'Items' => array(
        'Name' => array('Type' => 'String', 'Caption' => 'Přihlašovací jméno', 'Default' => ''),
        'Email' => array('Type' => 'String', 'Caption' => 'E-mail', 'Default' => ''),
      ),
    ));
    $this->System->FormManager->RegisterClass('UserLogin', array(
      'Title' => 'Přihlášení uživatele',
      'SubmitText' => 'Přihlásit',
      'Table' => '',
      'Items' => array(
        'Username' => array('Type' => 'String', 'Caption' => 'Přihlašovací jméno', 'Default' => ''),
        'Password' => array('Type' => 'Password', 'Caption' => 'Heslo', 'Default' => ''),
        'StayLogged' => array('Type' => 'Boolean', 'Caption' => 'Zůstat přihlášen', 'Default' => '0'),
      ),
    ));
    
  }  
  
  function DoStop()
  { 
  } 
}

class PagePortal extends Page
{
  var $FullTitle = 'Zděchovský rozcestník';
  var $ShortTitle = 'Rozcestník';
  
  function ShowActions($ActionGroup)
  {
    $Output = '';    
    $DbResult = $this->Database->query('SELECT `Id` FROM `Action` '.      
      'WHERE (`Action`.`Group`='.$ActionGroup['Id'].') AND (`Action`.`Enable` = 1)');
    while($Action = $DbResult->fetch_assoc())
    {
    	$Output .= $this->System->ShowAction($Action['Id']).'<br/>';
    }
    return($this->Panel($ActionGroup['Name'], $Output));
  }

  function InfoBar()
  {
    $Output2 = '';

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM NetworkDevice LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type WHERE NetworkDeviceType.ShowOnline = 1');
    $DbRow = $DbResult->fetch_array();
    $TotalComputers = $DbRow[0];

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM NetworkDevice LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type WHERE (NetworkDeviceType.ShowOnline = 1) AND (NetworkDevice.Online = 1)');
    $DbRow = $DbResult->fetch_array();    
    $OnlineComputers = $DbRow[0];

    $Output = '<img alt="" src="images/favicons/comp.png" width="16" height="16" /> '.$OnlineComputers.' / '.$TotalComputers.' &nbsp;  &nbsp; ';

    $DbResult = $this->Database->select('Member', 'COUNT(*)', '1');
    $DbRow = $DbResult->fetch_array();
    $TotalUser = $DbRow[0];

    $DbResult = $this->Database->query('SELECT COUNT(DISTINCT(Member)) FROM NetworkDevice '.
      'LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type '.
      'WHERE NetworkDeviceType.ShowOnline = 1 AND NetworkDevice.Online = 1');
    $DbRow = $DbResult->fetch_array();
    $OnlineUser = $DbRow[0];

    $Output .= '<img alt="" src="images/favicons/house.png" width="16" height="16" /> '.$OnlineUser.' / '.$TotalUser.' &nbsp;  &nbsp; ';

    $NetworkUsage = 0;
    $Output .= '<img alt="" src="images/favicons/usage.png" width="16" height="16" /> '.$NetworkUsage.' % &nbsp;  &nbsp; ';

    //$Output .= 'Server běží: '.$this->GetServerUptime().' &nbsp;  &nbsp; ';

    if($this->System->User->CheckPermission('Finance', 'DisplaySubjectState'))
    {
      $DbResult = $this->Database->select('MemberPayment', 'Cash', 'Member=(SELECT Customer FROM UserCustomerRel WHERE Id='.$this->System->User->User['Id'].')');
      if($DbResult->num_rows > 0)
      {
        $DbRow = $DbResult->fetch_assoc();
        $Output2 .= ' &nbsp;  &nbsp; <img alt="" src="images/favicons/money.png" width="16" height="16" /> '.$DbRow['Cash'].' Kč';
      }
    }

    $Output = '<div class="Navigation"><span class="MenuItem">'.$Output.'</span><div class="MenuItem2">&nbsp;'.$Output2.'</div></div>';
    return($Output);
  }

  function UserPanel()
  {
    $Output = '<a href="'.$this->System->Link('/?Action=UserOptions').'">Profil</a><br />';
    if($this->System->User->CheckPermission('Finance', 'MemberOptions')) 
      $Output .= '<a href="'.$this->System->Link('/?Action=MemberOptions').'">Domácnost</a><br />';
    if($this->System->User->CheckPermission('Finance', 'DisplaySubjectState')) 
      $Output .= '<a href="'.$this->System->Link('/finance/platby/').'">Finance</a><br />';
    if($this->System->User->CheckPermission('Network', 'RegistredHostList')) 
      $Output .= '<a href="'.$this->System->Link('/network/user-hosts/').'">Počítače</a><br />';
    if($this->System->User->CheckPermission('News', 'Insert')) 
      $Output .= '<a href="'.$this->System->Link('/aktuality/?action=add').'">Vložení aktuality</a><br />';
    if($this->System->User->CheckPermission('EatingPlace', 'Edit'))
      $Output .= '<a href="'.$this->System->Link('/jidelna/menuedit.php').'">Úprava jídelníčků</a><br />';
    if($this->System->User->CheckPermission('Finance', 'Manage'))
      $Output .= '<a href="'.$this->System->Link('/finance/sprava/').'">Správa financí</a><br />';
    if($this->System->User->CheckPermission('IS', 'Manage'))
      $Output .= '<a href="'.$this->System->Link('/is/').'">Správa dat</a><br />';
    return($Output);
  }

  function WebcamPanel()
  {
    $Output = $this->System->ModuleManager->Modules['WebCam']->ShowImage();
    return($Output);
  }

  function OnlineHostList()
  {
    $Output = '<span style="font-size: smaller;">';
    $DbResult = $this->Database->query('SELECT NetworkDevice.Name FROM NetworkDevice LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type WHERE (NetworkDeviceType.ShowOnline = 1) AND (NetworkDevice.Online = 1) ORDER BY NetworkDevice.Name');
    while($Device = $DbResult->fetch_array())
    {
      $Output .= $Device['Name'].'<br />';
    }
    $Output .= '</span>';
    return($Output);
  }

  function ShowBadPayerList()
  {
    $Output .= '<div class="PanelTitle">Dlužníci:</div><span style="font-size: smaller;">';
    $DbResult = $Database->select('Subject', 'Name', 'Money < 0 ORDER BY Money');
    while($Row = $DbResult->fetch_array())
    {
      $Output .= $Row['Name'].'<br />';
    }
    $Output .= '</span>';
    return($Output);
  }
   
  function Panel($Title, $Content, $Menu = array())
  {
    if(count($Menu) > 0) 
      foreach($Menu as $Item)
        $Title .= '<div class="Action">'.$Item.'</div>';
    return('<div class="Panel"><div class="Title">'.$Title.'</div><div class="Content">'.$Content.'</div></div>');
  }

  function Show()
  {
    $Output = '';
    if(array_key_exists('Action', $_GET))
    {
      $Action = $_GET['Action'];
      if($Action == 'CustomizeNewsSave')
      {
        $Output .= $this->System->ModuleManager->Modules['News']->CustomizeSave();
      } else
      if($Action == 'LoginForm')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserLogin');
        $Form->OnSubmit = '?Action=Login';
        $Output .= $Form->ShowEditForm();
        $Output .= '<div class="Centred"><a href="?Action=UserRegister">Registrovat se</a> '.
        '<a href="?Action=PasswordRecovery">Obnova zapomenutého hesla</a></div>';
      } else
      if($Action == 'Login')
      {
        if(array_key_exists('Username', $_POST) and array_key_exists('Password', $_POST))
        {
          $Form = new Form($this->System->FormManager);
          $Form->SetClass('UserLogin');
          $Form->OnSubmit = '?Action=Login';
          if(array_key_exists('StayLogged', $_POST) and ($_POST['StayLogged'] == 'on')) $StayLogged = true;
            else $StayLogged = false;          
          $Result = $this->System->User->Login($_POST['Username'], $_POST['Password'], $StayLogged);
          $Output .= $this->SystemMessage('Přihlášení', $Result);
          if($Result <> USER_LOGGED_IN)
          {
            $Form->LoadValuesFromForm();
            $Form->Values['Password'] = '';
            $Output .= $Form->ShowEditForm();
            $Output .= '<div class="Centred"><a href="?Action=UserRegister">Registrovat se</a> '.
              '<a href="?Action=PasswordRecovery">Obnova zapomenutého hesla</a></div>';
          } else {
            //$Output .= '<div class="Centred">Za 5 sekund budete přesměrováni na <a href="?Action=UserMenu">nabídku uživatele</a></div>';
            //Header('refresh:5;url=?Action=UserMenu');
            Header('Location: ?Action=UserMenu');
          }
        } else $Output .= $this->SystemMessage('Přihlášení', 'Nezadány přihlašovací údaje');
      } else 
      if($Action == 'Logout')
      {
        if($this->System->User->User['Id'] != null)
        {
          $Output .= $this->SystemMessage('Odhlášení', $this->System->User->Logout());
        } else $Output .= $this->SystemMessage('Nastavení uživatele', 'Nejste přihlášen');
      } else
      if($Action == 'UserOptions')
      { 
        if($this->System->User->User['Id'] != null)
        {
          $Form = new Form($this->System->FormManager);
          $Form->SetClass('UserOptions');
          $Form->LoadValuesFromDatabase($this->System->User->User['Id']);
          $Form->OnSubmit = '?Action=UserOptionsSave';
          $Output .= $Form->ShowEditForm();
        } else $Output .= $this->SystemMessage('Nastavení uživatele', 'Nejste přihlášen');
      } else
      if($Action == 'UserOptionsSave')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserOptions');
        $Form->LoadValuesFromForm();
        $Form->SaveValuesToDatabase($this->System->User->User['Id']);
        $Output .= $this->SystemMessage('Nastavení', 'Nastavení uloženo.');
        $this->System->ModuleManager->Modules['Log']->NewRecord('User', 'Nastavení uživatele změněno', $Form->Values['Name']);
        $Form->LoadValuesFromDatabase($this->System->User->User['Id']);
        $Form->OnSubmit = '?Action=UserOptionsSave';
        $Output .= $Form->ShowEditForm();
      } else
      if($Action == 'UserRegister')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserRegister');
        //$Form->LoadValuesFromForm();
        $Form->OnSubmit = '?Action=UserRegisterSave';
        $Output .= $Form->ShowEditForm();
      } else
      if($Action == 'UserRegisterConfirm')
      {
        $Output .= $this->SystemMessage('Potvrzení registrace', 
          $this->System->User->RegisterConfirm($_GET['User'], $_GET['H']));
      } else
      if($Action == 'PasswordRecovery')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('PasswordRecovery');
        $Form->OnSubmit = '?Action=PasswordRecovery2';
        $Output .= $Form->ShowEditForm();
      } else
      if($Action == 'PasswordRecovery2')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('PasswordRecovery');
        $Form->LoadValuesFromForm();
        $Result = $this->System->User->PasswordRecoveryRequest($Form->Values['Name'], $Form->Values['Email']);
        $Output .= $this->SystemMessage('Obnova hesla', $Result);
        if($Result <> USER_PASSWORD_RECOVERY_SUCCESS)
        {
          $Output .= $Form->ShowEditForm();
        }        
      } else
      if($Action == 'PasswordRecoveryConfirm')
      {
        $Output .= $this->SystemMessage('Obnova hesla', $this->System->User->PasswordRecoveryConfirm($_GET['User'], $_GET['H'], $_GET['P']));
      } else
      if($Action == 'UserRegisterSave')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserRegister');
        $Form->LoadValuesFromForm();
        $Result = $this->System->User->Register($Form->Values['Login'], $Form->Values['Password'], 
          $Form->Values['Password2'], $Form->Values['Email'], $Form->Values['Name'], $Form->Values['PhoneNumber'], $Form->Values['ICQ']);
        $Output .= $this->SystemMessage('Registrace nového účtu', $Result);
        if($Result <> USER_REGISTRATED) 
        {
          $Form->OnSubmit = '?Action=UserRegisterSave';
          $Output .= $Form->ShowEditForm();
        }
      } else
      if($Action == 'MemberOptions')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('MemberOptions');
        $DbResult = $this->Database->query('SELECT Customer FROM UserCustomerRel WHERE User='.$this->System->User->User['Id']);
        if($DbResult->num_rows > 0)
        {
          $CustomerUserRel = $DbResult->fetch_assoc();
          $DbResult = $this->Database->query('SELECT Member.Id, '.
            'Member.FamilyMemberCount, Member.BillingPeriodNext, Subject.Name, Subject.AddressStreet, '.
            'Subject.AddressTown, Subject.AddressPSC, Subject.AddressCountry, Subject.IC, Subject.DIC FROM Member JOIN Subject '.
           'ON Subject.Id = Member.Subject WHERE Member.Id='.$CustomerUserRel['Customer']);        
          $DbRow = $DbResult->fetch_array();
          foreach($Form->Definition['Items'] as $Index => $Item)
          {
            $Form->Values[$Index] = $DbRow[$Index];
          }
          $Form->OnSubmit = '?Action=MemberOptionsSave';
          $Output .= $Form->ShowEditForm();
        } else $Output .= $this->SystemMessage('Chyba', 'Nejste zákazníkem');
      } else
      if($Action == 'MemberOptionsSave')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('MemberOptions');
        $Form->LoadValuesFromForm();
        if($Form->Values['FamilyMemberCount'] < 0)
          $Form->Values['FamilyMemberCount'] = 0;
        if($Form->Values['BillingPeriodNext'] < 2)
          $Form->Values['BillingPeriodNext'] = 2;
          
        $DbResult = $this->Database->update('Member', 'Id='.$this->System->User->User['Member'], 
           array('FamilyMemberCount' => $Form->Values['FamilyMemberCount'], 
           'BillingPeriodNext' => $Form->Values['BillingPeriodNext']));
        $DbResult = $this->Database->query('SELECT Subject FROM Member WHERE Id='.$this->System->User->User['Member']);
        $Member = $DbResult->fetch_assoc();
        $DbResult = $this->Database->update('Subject', 'Id='.$Member['Subject'], 
          array('Name' => $Form->Values['Name'], 'AddressStreet' => $Form->Values['AddressStreet'], 
          'AddressTown' => $Form->Values['AddressTown'], 'AddressCountry' => $Form->Values['AddressCountry'],
          'AddressPSC' => $Form->Values['AddressPSC'], 'IC' => $Form->Values['IC'], 
          'DIC' => $Form->Values['DIC']));
        $Output .= $this->SystemMessage('Nastavení', 'Nastavení domácnosti uloženo.');
        $this->System->ModuleManager->Modules['Log']->NewRecord('Member+Subject', 'Nastavení člena/subjektu změněno', 
          $Form->Values['Name']);
        $DbResult = $this->Database->query('SELECT Member.Id, Member.FamilyMemberCount, Member.BillingPeriodNext, '.
          'Subject.Name, Subject.AddressStreet, Subject.AddressTown, Subject.AddressPSC, '.
          'Subject.AddressCountry, Subject.IC, Subject.DIC FROM Member JOIN Subject '.
          'ON Subject.Id = Member.Subject WHERE Member.Id='.$this->System->User->User['Member']);
        $DbRow = $DbResult->fetch_array();
        foreach($Form->Definition['Items'] as $Index => $Item)
        {
          $Form->Values[$Index] = $DbRow[$Index];
        }
        $Form->OnSubmit = '?Action=MemberOptionsSave';
        $Output .= $Form->ShowEditForm();
      } else 
      if($Action == 'UserMenu')
      {
        $Output = $this->ShowUserPanel();
      } else $Output = $this->ShowMain();
    } else $Output = $this->ShowMain();
    return($Output);
  }
    
  function ShowMain()
  {
    $Output = '';
    $DbResult = $this->Database->query('SELECT * FROM `ActionGroup`');
    while($DbRow = $DbResult->fetch_assoc())
      $ActionGroups[$DbRow['Id']] = $DbRow;

    // Show pannels
    //if(IsInternetAddr()) echo('Internet'); else echo('LAN');
    //$Output .= $this->InfoBar();
    $Output .= '<table id="MainTable"><tr>';
    $DbResult = $this->Database->select('PanelColumn', '*');
    while($PanelColumn =  $DbResult->fetch_assoc())
    {
      if($PanelColumn != '') $Width = ' width="'.$PanelColumn['Width'].'"'; 
        else $Width = '';
      $Output .= '<td valign="top"'.$Width.'>';
      $DbResult2 = $this->Database->query('SELECT * FROM `Panel` WHERE `PanelColumn`='.$PanelColumn['Id'].' ORDER BY `Order`');
      while($Panel = $DbResult2->fetch_assoc())
      {
        if($Panel['Module'] == 'ActionGroup') $Output .= $this->ShowActions($ActionGroups[$Panel['Parameters']]);
        else if($Panel['Module'] == 'OnlineHostList') $Output .= $this->Panel('Online počítače', $this->OnlineHostList());
        else if($Panel['Module'] == 'UserOptions') 
        {
          //if($this->System->User->User['Id'] != null) $Output .= $this->Panel('Přihlášený uživatel', $this->UserPanel());
        } else
        if($Panel['Module'] == 'Webcam') $Output .= $this->Panel('Kamery', $this->WebcamPanel());
        else if($Panel['Module'] == 'NewsGroupList') 
          $Output .= $this->Panel('Aktuality', $this->System->ModuleManager->Modules['News']->Show(), array('<a href="?Action=CustomizeNews">Upravit</a>'));
      }
      $Output .= '</td>';
    }  
    $Output .= '</tr></table>';
    return($Output);
  }
  
  function ShowUserPanel()
  {
    $Output = '';
    if($this->System->User->User['Id'] != null)
    { 
      $Output .= '<div class="Centred"><table id="MainTable"><tr><td>';
      $Output .= $this->Panel('Nabídka uživatele', $this->UserPanel());
      $Output .= '</td><td>';
      //$Output .= $this->Panel('Přehled', $this->UserPanel());
      $Output .= '</td></tr></table></div>';
    } else $Output .= $this->SystemMessage('Oprávnění', 'Nejste přihlášen');
    return($Output);
  }
}
